#include <stdio.h>
#include "linda3.h"

typedef struct barriere
{
	char nom[40] ;
	long num ;
} BARRIERE ;


int main(int argc, char *argv[])
{
	int nbslave ;
	BARRIERE b, i_go ;
	TupleType barr 		= DefineTupleType("Barriere", "{c[40]l}") ;
	TupleSelector sel 	= CreateTupleSelector( barr , "{.?}" ) ;
	int k ;
	WORD t1, t2 ;
		
	if( argc != 2 )
	{
		printf("\nusage: barm nombre_d_esclaves\n\n") ;
		UndefTupleType(barr) ;
		exit(-1) ;
	}
	nbslave = atoi(argv[1]) ;
	
		
	SCREEN ;
	printf("\n Debut lancement esclaves" ) ;
	NOSCREEN ;

	t1 = _cputime() ;

	/* activer les esclaves */
	for( k = 0 ; k < nbslave ; ++k)
		Eval("bars" , &barr, 1 , &k , (long)sizeof(k) )  ;
		
	t2 = _cputime() ;
	SCREEN ;
	printf("\n Fin lancement esclaves : %lf sec./esclave " , 
		(t2-t1) / 100.0 / nbslave ) ;
	NOSCREEN ;
	
	MakeByteArray(b.nom,"BARRIER") ;
	MakeByteArray(i_go.nom, "I-GO" ) ;

	t1 = _cputime() ;

	b.num = nbslave ;
	k = out(barr, &b) ;
		
	for (k = 0 ; k < nbslave ; ++k) 
	{
		in(sel , &i_go ) ;
	}
	
	in(sel , &b ) ;
	
	t2 = _cputime() ;
	t2 = t2 - t1 ;
	
	SCREEN ;
	printf("\n Fin de synchronisation : %lf sec. (%lf sec./esclave)" ,
		 t2 / 100.0 , t2 / 100.0 / nbslave) ;
	NOSCREEN ;

	/* nettoyage */
	free(sel ) ;
	UndefTupleType(barr) ; 
}
	
	
	
